]>
git.saurik.com Git - bison.git/blob - bootstrap
3 # Bootstrap this package from CVS.
5 # Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2, or (at your option)
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
22 # Written by Paul Eggert.
26 # Ensure file names are sorted consistently across platforms;
27 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
28 # Also, ensure diagnostics are in English, e.g., "wget --help" below.
38 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
41 GNULIB_SRCDIR
=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
43 CVS_USER
=`expr "$option" : '--cvs-user=\(.*\)'`;;
47 echo >&2 "$0: $option: unknown option"
52 echo "$0: Bootstrapping CVS $package..."
56 if [ "${2}" != - ]; then
57 CVS_PREFIX
=${CVS_PREFIX}${2}@
63 case ${GNULIB_SRCDIR--} in
65 if [ ! -d gnulib
]; then
66 echo "$0: getting gnulib files..."
69 trap 'rm -fr gnulib; exit 1' 0
71 case ${CVS_AUTH-anoncvs} in
73 CVS_PREFIX
='anoncvs@';;
75 CVS_PREFIX
="$CVS_USER${CVS_USER+@}";;
77 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
82 '') export CVS_RSH
=ssh;;
85 cvs
-z3 -q -d ${CVS_PREFIX}subversions.gnu.org
:/cvsroot
/gnulib co gnulib
|| exit
92 <$GNULIB_SRCDIR/gnulib
-tool || exit
120 previous_gnulib_modules
=
121 while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
122 previous_gnulib_modules
=$gnulib_modules
124 (echo "$gnulib_modules"
125 for gnulib_module in $gnulib_modules; do
126 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
132 (for gnulib_module in $gnulib_modules; do
133 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
137 gnulib_dirs
=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
138 mkdir -p $gnulib_dirs || exit
140 for gnulib_file
in $gnulib_files; do
144 m
4/onceonly_2_57.
m4) dest
=m
4/onceonly.
m4;;
145 # These will be overwritten by autopoint, which still uses
146 # old jm_.* macro names, so we have to keep both copies.
147 # m4/gettext.m4 isn't mentioned here, since it's patched below.
148 m
4/glibc21.
m4 | m
4/inttypes_h.
m4 | m
4/lib
-ld.
m4 | \
149 m
4/lib
-prefix.
m4 | m
4/po.
m4 | m
4/stdint_h.
m4 | m
4/uintmax_t.
m4 | \
151 dest
=`expr $gnulib_file : '\(.*\).m4'`_gl.
m4;;
155 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
156 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
159 # This suppresses a bogus diagnostic
160 # "warning: macro `AM_LANGINFO_CODESET' not found in library".
161 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
163 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
164 AC_DEFUN([AM_INTL_SUBDIR], [])
165 ' m
4/gettext.
m4 >m
4/gettext_gl.
m4 || exit
172 case `wget --help` in
174 no_cache
='--no-cache';;
176 no_cache
='--cache=off';;
181 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
183 rm -f dummy
`ls | sed -n '/\.gmo$/p; /\.po/p'` &&
184 wget
-nv -nd -r -l 1 -A .po
$no_cache \
185 http
://www.iro.umontreal.ca
/translation
/maint
/$package/ &&
186 ls *.po
| sed 's/\.po$//' >LINGUAS
191 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
193 rm -f dummy
`ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
194 wget
-nv -nd -r -l 1 -A .po
$no_cache \
195 http
://www.iro.umontreal.ca
/translation
/maint
/$package-runtime/ &&
197 # For translations that have not yet been upgraded to the new
198 # runtime-po domain, prime the pump by extracting the relevant
199 # strings from the obsolete translations.
200 # This code can be removed once the bison-runtime domain
201 # has been translated by each team.
202 for po
in ..
/po
/*.po
; do
203 test -f "$po" || continue
207 -e 'memory exhausted' \
212 /^msgid "syntax error; also memory exhausted"$/,/^$/d
215 if cmp -s $runpo- $runpo; then
220 test -s $runpo || rm -f $runpo
224 ls *.po
| sed 's/\.po$//' >LINGUAS
230 # Generate autoconf and automake snippets.
232 (echo '# This file is generated automatically by "bootstrap".' &&
233 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
234 $GNULIB_SRCDIR/gnulib
-tool --extract-autoconf-snippet $gnulib_modules &&
236 ) >m
4/gnulib.
m4 || exit
238 (echo '# This file is generated automatically by "bootstrap".' &&
239 $GNULIB_SRCDIR/gnulib
-tool --extract-automake-snippet $gnulib_modules
240 ) >lib
/gnulib.mk
|| exit
243 # Reconfigure, getting other files.
245 echo "$0: autoreconf --verbose --install --force ..."
246 autoreconf
--verbose --install --force || exit
249 # We don't need intl, so remove it.
250 # Remove aclocal.m4 too, so that it gets rebuilt.
251 intl_files_to_remove
='
280 echo $0: rm -fr $intl_files_to_remove ...
281 rm -fr $intl_files_to_remove || exit
283 # Put bug-reporting address into po/Makevars.
284 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
285 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po
/Makevars.template
>po
/Makevars
287 # Likewise for runtime-po/Makevars, except also change a few other parameters.
289 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
290 s/^\(subdir\) *=.*/\1 = runtime-po/
291 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
292 ' <po
/Makevars
>runtime
-po/Makevars
294 # Copy identical files from po to runtime-po.
295 (cd po
&& cp -p Makefile.
in.
in *-quot *.header
*.
sed *.sin ..
/runtime
-po)
297 # if src/parse-gram.[ch] are out of date, rebuild them.
298 parse_gram_y
=`find src/parse-gram.y \
299 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
301 case $parse_gram_y in
303 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
305 echo "$0: touch -c src/parse-gram.[ch] ... "
306 touch -c src
/parse
-gram.
[ch
] || exit
308 echo "$0: ./configure --disable-nls ..."
309 .
/configure
--disable-nls || exit
311 echo "$0: (cd lib && make) ..."
312 (cd lib
&& make) || exit
314 echo "$0: (cd src && make) ..."
315 (cd src
&& make) || exit
317 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
318 rm -f src
/parse
-gram.c src
/parse
-gram.h
|| exit
320 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
321 (cd src
&& make parse
-gram.c parse
-gram.h
) || exit
323 echo "$0: make distclean ..."
324 make distclean
|| exit;;
327 echo "$0: done. Now you can run './configure'."